package com.example.what_the_fantasy.data.services

import android.util.Log
import com.example.what_the_fantasy.data.local.UserStub.users
import com.example.what_the_fantasy.data.model.Comment
import com.example.what_the_fantasy.data.model.Favorite
import com.example.what_the_fantasy.data.model.Quote
import com.example.what_the_fantasy.data.model.SrcLanguage
import com.example.what_the_fantasy.data.model.User
import com.example.what_the_fantasy.data.retrofit.RetrofitInstance
import com.example.what_the_fantasy.data.retrofit.UserUpdateRequest
import com.example.what_the_fantasy.ui.viewModels.CurrentUserViewModel

//import com.example.what_the_fantasy.data.model.Comment
//import com.example.what_the_fantasy.data.model.Favorite
//import com.example.what_the_fantasy.data.model.Quote
//import com.example.what_the_fantasy.data.model.User
////import com.example.what_the_fantasy.ui.navigations.Destination

class ServicesAPI : IServices {

    override suspend fun validLogin(
        username: String,
        passwd: String,
        navController: (Int) -> Unit,
        initialierCurrentUser: (Int) -> Unit,
        currentUserViewModel: CurrentUserViewModel
    ): Boolean {
        try {
            val response = RetrofitInstance.api.getUserByUsername(username) // on récupère l'utilisateur
            val hashedPasswordAPI = response.password // récupère le mot de passe de l'api
            val index =response.id
            //val hashPassWd = hashPassword(passwd)// hache mot de passe demandé

            if (passwd == hashedPasswordAPI) { // on compare les deux mots de passe
                navController(index)
                initialierCurrentUser(index)
                currentUserViewModel.setUser(response)
                return true
            }
            else {
                return false
            }
        } catch (e: Exception) {
            return false
        }
    }

    override suspend fun EditUsername(username: String, index: Int): Boolean {
        try {
            val responseOldUser = RetrofitInstance.api.getUserById(index)
            val request = UserUpdateRequest(username,
                responseOldUser.email,
                responseOldUser.password,
                responseOldUser.langage,
                responseOldUser.imgUrl)


            return false
        }catch (e: Exception) {
            return false
        }
    }

    override suspend fun EditEmail(email: String, index: Int): Boolean {
        try {
            val responseOldUser = RetrofitInstance.api.getUserById(index)
            val request = UserUpdateRequest(responseOldUser.username,
                email,
                responseOldUser.password,
                responseOldUser.langage,
                responseOldUser.imgUrl)


            return false
        }catch (e: Exception) {
            return false
        }
    }


    override suspend fun EditPasswd(passwd: String, index: Int) {
        try {
            val responseOldUser = RetrofitInstance.api.getUserById(index)
            val request = UserUpdateRequest(responseOldUser.username,
                responseOldUser.email,
                passwd,
                responseOldUser.langage,
                responseOldUser.imgUrl)

        }catch (_: Exception) { }
    }

    override fun EditImage(index: Int): String {
        TODO("Not yet implemented")
    }

    override fun ChangeLangage(index: Int): SrcLanguage {
        TODO("Not yet implemented")
    }

    override fun isUsernameExist(username: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun isEmailExist(email: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun AddFav(userId: Int, QuoteId: Int) {
        TODO("Not yet implemented")
    }

    override fun SupFav(userId: Int, QuoteId: Int) {
        TODO("Not yet implemented")
    }

    override fun AddComment(content: String) {
        TODO("Not yet implemented")
    }

    override fun CreateUser(username: String, email: String, passwd: String): Boolean {
        TODO("Not yet implemented")
    }

    override fun getFavorite(user: User): List<Quote> {
        TODO("Not yet implemented")
    }

    override fun getAllUsers(): List<User> {
        TODO("Not yet implemented")
    }

    override fun getComment(quoteId: Int): List<Comment> {
        TODO("Not yet implemented")
    }

    override suspend fun getUserById(id: Int): User {
        return RetrofitInstance.api.getUserById(id)
    }

    override fun getQuote(id: Int): Quote? {
        TODO("Not yet implemented")
    }

    override suspend fun isFavorite(idQuote: Int, iduser: Int): Boolean {
        TODO("Not yet implemented")
    }

    override fun getAllFavorite(): List<Favorite> {
        TODO("Not yet implemented")
    }

    override fun getAllQuote(): List<Quote> {
        TODO("Not yet implemented")
    }

    override fun getSomeQuotes(nb: Int, page: Int): MutableList<Quote> {
        TODO("Not yet implemented")
    }

    override fun search(type: String, search: String, indexCount: Int): List<Quote> {
        TODO("Not yet implemented")
    }

}